C*****************************************************************
C   header file for irregular express code
C
C*****************************************************************
      
      IMPLICIT NONE

      INTEGER ENV(4)
      
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC
      INTEGER         NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC
      
      INTEGER PROCNUM, NPROCS, ISWAP 
      COMMON /PROCINFO/ PROCNUM, ISWAP 

      INTEGER MaxDegree
      PARAMETER (MaxDegree=40)

      INTEGER TwoTo25,TwoTo26,TwoTo30 
      PARAMETER (TwoTo25=33554432)
      PARAMETER (TwoTo26=67108864)
      PARAMETER (TwoTo30=1073741824)

      INTEGER FROMND(2)
      INTEGER PGIND, NODES
      INTEGER SRC, TYPE, DUMMY, STATUS

      INTEGER KXTSWA, KXRUN, KXBROD, KXREAD, KXWRIT, KXCOMB, KXCONC
      EXTERNAL KXTSWA, KXRUN, KXBROD, KXREAD, KXWRIT, KXCOMB, KXCONC

      INTEGER np,npm,n18m,dim,dm,nprocsm
      INTEGER nx, ny, nm, n6, n6m, n
      PARAMETER ( nx =    32)
      PARAMETER ( ny =    32)
      PARAMETER ( n  = nx * ny )
      PARAMETER ( n6 = 6 * n )
      PARAMETER ( n6m = n6 - 1 )
      PARAMETER ( nm =   n - 1 )
      PARAMETER ( nprocs =  16)
      PARAMETER ( nprocsm = nprocs - 1 )
      PARAMETER ( np= n /nprocs)
      PARAMETER ( npm = np -1)
      PARAMETER ( n18m = 3*n6 - 1)
      PARAMETER ( dim = 3 )
      PARAMETER ( dm = dim - 1 )
      INTEGER proc_n(0:npm), neigh(0:npm,0:MaxDegree) 
C      REAL ncoord(0:npm,0:60,0:3) ! coordinates (what is 60?)
C      COMMON /NINFO/ neigh, ncoord
      COMMON /NINFO/ neigh
      REAL coord_of_s(0:dm,0:npm)
      COMMON /MYINFO/ proc_n, coord_of_s

C==========================================================================
C================ Data Structures for Parallel Coloring Code===============
C==========================================================================
 
C     label, color, color_queue, temp_queue
C     are all of size = total number of vertices!!
C     This should be changed!
        
      integer label(0:nm),temp_label(0:npm)
      integer color(0:nm),color_count,temp_color(0:npm)
      COMMON /colorinfo/ color,color_count,color_index,temp_color
      COMMON /labelinfo/ label, temp_label,color_queue,temp_queue
      integer internal(0:npm),external(0:npm) !vSi,vSl for Jones&Plassman
      integer icount,ecount
      integer flag,color_queue(0:nm)
C      integer n_wait(0:npm),send_queue(0:nm)
      integer global,color_index,local,temp_queue(0:nm)

      INTEGER send(0:np,0:MaxDegree),dest(0:nprocsm)
      INTEGER source(0:nprocsm)
      COMMON /COMM_SCHED/ source,dest
      COMMON /INTANDEXT/ icount,ecount,internal,external
 
C     added for tallying up average colors and time
      integer totalcols(1:3), totaltime(1:3)
      COMMON /totals/ totalcols, totaltime

